﻿using System;
using System.Collections.Generic;
using System.Text;
#region 命名空间
using SocketCommon;
using System.Net;
using System.Net.Sockets;
#endregion

namespace ClientConsole
{
    /// <summary>
    /// tcp通讯类(客户端)
    /// </summary>
    public class TcpClient : TcpCommon
    {
        #region 异步连接服务器
        /// <summary>
        /// 连接到服务器
        /// </summary>
        public void AsynConnect()
        {
            IPEndPoint serverIp = new IPEndPoint(IPAddress.Parse("127.0.0.1"), 8686);
            Socket tcpClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            tcpClient.BeginConnect(serverIp, asyncResult =>
            {
                tcpClient.EndConnect(asyncResult);
                base.worksocket = tcpClient;
                Console.WriteLine("client-->-->{0}", serverIp.ToString());
                base.handlerMsg = new HandlerMessage();
                base.reciveAction = msgPro =>
                {
                    if (msgPro.MessageType == MessageType.text)//是文本信息
                    {
                        Console.WriteLine("client<---{0}:{1}", serverIp.ToString(), msgPro.MessageInfo.Content);
                    }
                    else new UdpServer(msgPro.RequestFile);//是文件
                };
                AsynRecive(base.reciveAction);
            }, null);
        }
        #endregion
    }
}
