﻿using System;
using System.Collections.Generic;
using System.Text;
#region 命名空间
using SocketCommon;
using System.Net;
using System.Net.Sockets;
#endregion

namespace ServerConsole
{
    /// <summary>
    /// tcp通讯类(服务器)
    /// </summary>
    public class TcpServer : TcpCommon
    {
        #region 开启监听
        /// <summary>
        /// 开始监听
        /// </summary>
        public void Listen()
        {
            IPEndPoint serverIp = new IPEndPoint(IPAddress.Any, 8686);
            Socket tcpServer = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            tcpServer.Bind(serverIp);
            tcpServer.Listen(100);
            Console.WriteLine("server ready.");
            base.reciveAction = msgPro =>
            {
                if (msgPro.MessageType == MessageType.text)//是文本信息
                {
                    Console.WriteLine("server<---{0}:{1}", base.worksocket.RemoteEndPoint.ToString(), msgPro.MessageInfo.Content);
                    string feedback = "收到消息.";
                    Console.WriteLine("server--->{0}:{1}", base.worksocket.RemoteEndPoint.ToString(), feedback);
                    AsynSend(new MessageProtocol(feedback));
                }
                else new UdpClient(msgPro.RequestFile);//是文件
            };
            AsynAccept(tcpServer);
        }
        #endregion

        #region 与客户端建立新连接
        /// <summary>
        /// 异步尝试建立客户端与服务器端的连接
        /// </summary>
        /// <param name="tcpServer"></param>
        public void AsynAccept(Socket tcpServer)
        {
            tcpServer.BeginAccept(asyncResult =>
            {
                base.worksocket = (Socket)tcpServer.EndAccept(asyncResult);
                Console.WriteLine("server<---{0}.", base.worksocket.RemoteEndPoint.ToString());
                AsynAccept(tcpServer);
                AsynRecive(reciveAction);
            }, null);
        }
        #endregion
    }
}