﻿using System;
using System.Collections.Generic;
using System.Text;
#region 命名空间
using System.IO;
#endregion

namespace SocketCommon
{
    public class FileManager : IDisposable
    {
        public FileObject fileobject;
        public FileStream filestream;
        public Status status = Status.keepon;
        public long offset = 0;
        // 获得文件发送/接收的百分比
        public string GetPercent()
        {
            decimal allBytes = Convert.ToDecimal(fileobject.FileLength);
            decimal currentSent = Convert.ToDecimal(offset);

            decimal percent = (currentSent / allBytes) * 100;
            percent = Math.Round(percent, 1);	//保留一位小数

            if (percent.ToString() == "100.0")
                return "100";
            else
                return percent.ToString();
        }
        public void Dispose()
        {
            if (filestream != null)
            {
                filestream.Close();
            }
        }
    }
}
