﻿using System;
using System.Collections.Generic;
using System.Text;
#region 命名空间
using System.IO;
#endregion

namespace SocketCommon
{
    public class FileSendManager : FileManager
    {
        public FileSendManager(FileObject _fileobject)
        {
            fileobject = _fileobject;
            fileobject.PacketSize = 1024;
            filestream = new FileStream(
                fileobject.FileName,
                FileMode.Open,
                FileAccess.Read,
                FileShare.Read,
                fileobject.PacketSize * 10);
            fileobject.FileLength = filestream.Length;
            fileobject.PacketCount = fileobject.FileLength / fileobject.PacketSize;
            if (fileobject.FileLength % fileobject.PacketSize != 0)
            {
                fileobject.PacketCount++;
            }
        }
        public byte[] Read()
        {
            byte[] buffer;
            if (fileobject.FileLength - offset < fileobject.PacketSize)
            {
                buffer = new byte[fileobject.FileLength - offset];
            }
            else
            {
                buffer = new byte[fileobject.PacketSize];
            }
            filestream.Position = offset;
            filestream.Read(buffer, 0, buffer.Length);
            offset += buffer.Length;
            return buffer;
        }
    }
}
