﻿using System;
using System.Collections.Generic;
using System.Text;
#region 命名空间
using System.Collections;
using System.Text.RegularExpressions;
using System.Xml;
#endregion

namespace SocketCommon
{
    public class HandlerMessage
    {
        //临时缓存
        public string temp = string.Empty;
        //匹配协议获取信息
        public List<MessageProtocol> HandlerString(string msg)
        {
            List<MessageProtocol> msgProList = new List<MessageProtocol>();
            if (!String.IsNullOrEmpty(temp))
            {
                msg = temp + msg;
            }
            string pattern = "(^<protocol Type=.*?>.*?</protocol>)";
            if (Regex.IsMatch(msg, pattern))
            {
                //匹配协议内容
                string match = Regex.Match(msg, pattern).Groups[0].Value;
                //将匹配的内容添加到集合
                msgProList.Add(HandlerObject(match));
                temp = string.Empty;
                //截取未匹配字符串，进行下一次匹配
                msg = msg.Substring(match.Length);
                if (!String.IsNullOrEmpty(msg))
                {
                    msgProList.AddRange(HandlerString(msg));
                }
            }
            else
            {
                temp = msg;
            }
            return msgProList;
        }
        //将已转成协议信息转成对象信息
        public MessageProtocol HandlerObject(string protocol)
        {
            XmlDocument xmldoc = new XmlDocument();
            xmldoc.LoadXml(protocol);
            XmlNode root = xmldoc.DocumentElement;
            XmlNode msgnode = root.SelectSingleNode("message");
            MessageProtocol msgPro = new MessageProtocol();
            if (root.Attributes["Type"].Value == MessageType.text.ToString())
            {
                msgPro.MessageType = MessageType.text;
                msgPro.MessageInfo = new MessageInfo(msgnode.Attributes["Content"].Value);
            }
            else
            {
                msgPro.MessageType = MessageType.file;
                RequestMode mode = (RequestMode)Enum.Parse(typeof(RequestMode), msgnode.Attributes["Mode"].Value);
                FileObject fileobject = new FileObject();
                fileobject.FileName = msgnode.Attributes["FileName"].Value;
                fileobject.FileLength = Convert.ToInt64(msgnode.Attributes["FileLength"].Value);
                fileobject.PacketSize = Convert.ToInt32(msgnode.Attributes["PacketSize"].Value);
                fileobject.PacketCount = Convert.ToInt64(msgnode.Attributes["PacketCount"].Value);
                msgPro.RequestFile = new RequestFile(
                    msgnode.Attributes["Address"].Value,
                    Convert.ToInt32(msgnode.Attributes["Port"].Value),
                    mode, fileobject);
            }
            return msgPro;
        }
    }
}
