﻿using System;
using System.Collections.Generic;
using System.Text;
#region 命名空间
using System.Net.Sockets;
using System.Net;
#endregion

namespace SocketCommon
{
    /// <summary>
    /// Tcp异步通讯公有类
    /// 实现server与client相同方法
    /// </summary>
    public abstract class TcpCommon
    {
        protected Socket worksocket;//当前套接字
        public Action<MessageProtocol> reciveAction;//信息处理
        protected HandlerMessage handlerMsg = new HandlerMessage();//信息协议处理类

        /// <summary>
        /// 异步接受信息
        /// </summary>
        /// <param name="ReciveAction"></param>
        protected void AsynRecive(Action<MessageProtocol> ReciveAction)
        {
            byte[] data = new byte[1024];
            worksocket.BeginReceive(data, 0, data.Length, SocketFlags.None,
            asyncResult =>
            {
                int length = worksocket.EndReceive(asyncResult);
                string msg = Encoding.UTF8.GetString(data, 0, length);
                foreach (MessageProtocol item in handlerMsg.HandlerString(msg))
                {
                    ReciveAction(item);
                }
                AsynRecive(ReciveAction);
            }, null);
        }
        /// <summary>
        /// 异步发送信息
        /// </summary>
        /// <param name="msgPro"></param>
        public void AsynSend(MessageProtocol msgPro)
        {
            byte[] data = Encoding.UTF8.GetBytes(msgPro.ToString());
            worksocket.BeginSend(data, 0, data.Length, SocketFlags.None, asyncResult =>
            {
                //完成发送消息
                int length = worksocket.EndSend(asyncResult);
            }, null);
        }
    }
}
