﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Timers;

namespace SocketCommon
{
    public class TimerManager
    {
        public delegate void ElapsedDelegate();
        public event ElapsedDelegate ElapsedEvent;
        public Timer Timer { get; set; }
        public int TimeOut { get; set; }
        public bool IsRuning { get; set; }
        public TimerManager(double interval)
        {
            this.Timer = new Timer(interval);
            this.Timer.Elapsed += new ElapsedEventHandler(Timer_Elapsed);
        }
        public void Timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            this.TimeOut++;
            ElapsedEvent.Invoke();
        }
        public void Start()
        {
            this.Timer.Start();
            IsRuning = true;
        }
        public void Stop()
        {
            if (this.TimeOut != 0)
            {
                this.TimeOut = 0;
            }
            this.Timer.Stop();
            IsRuning = false;
        }
    }
}
